//+-------------------------------------------------------------------------------+ 
//|                                                     TrendStrengthExpertEA.mq4 |
//|                                                     original by Igorad        |
//|                                                     mod by mrtools            |
//+-------------------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"

//
//
//
//
//

#include <stdlib.mqh>
#include <stderror.mqh>
#define  PAUSE_BEFORE_RETRY 500

//
//
//
//
//

extern bool   NoHedge              = false;
extern bool   StrictNoHedge        = false;
extern string SymbolsPrefix        = "";
extern string SymbolsSuffix        = "";
extern bool   UseAutoMagic         = true;
extern int    ManualMagic          = 123123123; 
extern bool   EcnBroker            = true;
extern int    Slippage             =  3;

extern string Main_data            = "Trade Volume & Trade Method";
extern double Lots                 = 0.1;      // Trade Volume 
extern int    MaxOrders            = 2;
extern double TakeProfit           = 400;      // Take Profit Value in pips 
extern double StopLoss             = 100;      // Initial Stop Value in pips
extern int    TrailingStop         = 30;
extern int    MinimumProfit        = 20;       // minimum in profit before trailing stop starts
extern double MoneyRisk            = 1;        // Deviation of VoltyChannel_Stop or MoneyRisk
extern string ex_exit              = "System Exit Switch:0-off,";
extern string ex_exit2             = "1=TS,2=TE,3=Volty,";
extern string ex_exit3             = "4=kst,5-7=signal various";
extern string ex_exit4             = "8=AS,9=AS&TS";
extern int    ExitMode             = 0;        // System Exit Switch:0-off,1-TS,2-TE,3-KST_Signal,4-any first,5-signal

extern string Time_Inputs          = "Timing parameters ";
extern int    TradeDay             = -1;       // Trade Day of Week (ex.1-Monday,-1-all Days) 
extern int    NonTradeDay          = 0;        // Non Trade Day of Week
extern int    StartHour            = 0;        // Start Hour of Trade Session 
extern int    StartMinute          = 0;        // Start Minute of Trade Session 
extern int    EndHour              = 23;       // End Hour of Trade Session
extern int    EndMinute            = 0;        // End Hour of Trade Session
extern int    MonStartHour         = 8;        // Monday Start Hour of Trade Session 
extern int    MonStartMinute       = 0;        // Monday Start Minute of Trade Session
extern int    FriEndHour           = 18;       // Friday End Hour of Trade Session
extern int    FriEndMinute         = 0;        // Friday End Hour of Trade Session 
extern int    CloseTimeMode        = 0;        // CloseTime mode: 0-off,1-on
extern int    CloseHour            = 24;       // Trade Close Hour   
extern int    CloseMinute          = 0;        // Trade Close Minute 
extern int    FriCloseHour         = 20;       // Trade Close Hour in Friday   
extern int    FriCloseMinute       = 55;       // Trade Close Minute in Friday 
extern double ProcessTime          = 3;  
extern bool   showMessages         = false;

extern string IND_Inputs           = "Indicators parameters";


extern int    TE_TimeFrame         = 30; 
extern int    TE_Length            = 14;
extern double TE_Phase             = 0;
extern bool   TE_Double            = false;
extern int    TE_UpperPrice        = PRICE_CLOSE;
extern int    TE_LowerPrice        = PRICE_CLOSE;
extern double TE_Deviation         = 0.2;
extern int    TE_CurBar            = 1;        // Shift relative to the current bar

extern int    TE_Mode              = 0;        // TE Mode: 0-off,1-trend(confirmation),2-signal

extern int    VS_TimeFrame         = 30; 
extern int    VS_Price             = 0;
extern double VS_SmoothLength      = 10;
extern double VS_SmoothPhase       = 0;
extern bool   VS_SmoothDouble      = true;
extern int    VS_ATRLength         = 10; 
extern double VS_Kv                = 4;  
extern double VS_MoneyRisk         = 1; 
extern int    VS_CurBar            = 1;        // Shift relative to the current bar

extern int    VS_Mode              = 0;        // VS Mode: 0-off,1-trend(confirmation),2-signal

extern int    TS_TimeFrame         = 0;       // Time Frame in min
extern int    TS_RsxLength         = 12;
extern int    TS_SmoothLength      = 5;
extern double TS_SmoothPhase       = 0;
extern bool   TS_SmoothDouble      = true;
extern int    TS_Price             = 0;
extern double TS_Kv                = 4.236;    // Multiplier 
extern int    TS_CurBar            = 1;        // Shift relative to the current bar

extern int    TS_Mode              = 0;        // TS Mode: 0-off,1-trend(confirmation),2-signal

extern int    LT_KST_TimeFrame     = 0;
extern int    LT_KSTType           = 2;
extern int    LT_KSTMaType         = 3;
extern int    LT_KSTSignalMaPeriod = 22;
extern int    LT_KST.BarToCheck    = 1;

extern int    ST_KST_TimeFrame     = 0;
extern int    ST_KSTType           = 0;
extern int    ST_KSTMaType         = 3;
extern int    ST_KSTSignalMaPeriod = 9;
extern int    ST_KST.BarToCheck    = 1;
extern int    KST_Mode             = 2;         // Add Mode: 0-off,1-trend(confirmation),2-signal

extern int    AS_TimeFrame         = 0;        // Time Frame in min
extern int    AS_MathMode          = 1;         // 0-RSI method; 1-Stoch method; 2-ADX method
extern int    AS_Length            = 10;        // Period of evaluation
extern int    AS_Smooth            = 5;         // Period of smoothing
extern int    AS_Signal            = 5;         // Period of Signal Line
extern int    AS_Price             = 0;         // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    AS_ModeMA            = 3;         // Mode of Moving Average
extern int    AS_CurBar            = 1;         // Shift relative to the current bar
extern int    AS_Mode              = 0;
       
extern string MM_inputs            = "MoneyManagement by L.Williams";
extern bool   MM                   = true;      //  Switch
extern double MaxRisk              = 0.05;      // Risk Factor
extern double MaxLoss              = 1000;      // Maximum Loss by 1 Lot

//
//
//
//
//

int      Magic;
int      OrderBar=0;
int      BEvent=0, TriesNum = 5;
int      NumberOfTries = 5;

datetime CurrBar,PrevBar;

double   Lotsi;
double   UpLine,DnLine;
double   TStrend, pTStrend, VStrend, pVStrend, TEtrend, pTEtrend;
double   LT_trendNow, LT_trendPre,LT_sigNow, LT_sigPre;
double   ST_trendNow, ST_trendPre,ST_sigNow, ST_sigPre;
double   Bulls, sBulls, Bears, sBears;
double   _Point = 1;

//
//
//
//
//

string  s_symbol;
string  IEAMessagesID;
int     IEAMessagesIDLength;
#define IEAMessagesIDMagic EMPTY_VALUE
#define IEAMessagesIDExSep "-ex:"


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//
//

int init()
{
   s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic;
   
   //
   //
   //
   //
   //
              
   IEAMessagesID = "JTS"+Magic+Symbol();
   IEAMessagesIDLength = StringLen(IEAMessagesID);
   IEAMessagesIDLength = StringLen(IEAMessagesID);
   
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:  break;
      case REASON_RECOMPILE:
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:     if (showMessages) for(int i = 0; i < 10; i++)  ObjectDelete("msg.que"+i);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (!CheckTerminalStatus()) return(0); showTwoStateMessage("working","J_TS EA working",true);
   
   //
   //
   //
   //
   //
   
   if (TE_TimeFrame     == 0) TE_TimeFrame     = Period();
   if (TS_TimeFrame     == 0) TS_TimeFrame     = Period();
   if (VS_TimeFrame     == 0) VS_TimeFrame     = Period();
   if (LT_KST_TimeFrame == 0) LT_KST_TimeFrame = Period(); 
   if (ST_KST_TimeFrame == 0) ST_KST_TimeFrame = Period();  
   if (AS_TimeFrame     == 0) AS_TimeFrame     = Period();
   
   //
   //
   //
   //
   //
   
   if(iBars(Symbol(),VS_TimeFrame) < 100 || IsTradeAllowed() == false) return(0);  
   
   //
   //
   //
   //
   //
   
   if (Digits == 3 || Digits == 5) 
        _Point = 10;   
   else _Point = 1;  
   
	//
   //
   //
   //
   //
     
   if(AccountFreeMargin() < 1000 * MoneyManagement())
      { showTwoStateMessage("money","Not enough money to trade "+AccountFreeMargin(),false); return(0); }
   else showTwoStateMessage("money","Continuing to trade",true);
   
   //
   //
   //
   //
   //
   
   CurrBar = iTime(Symbol(),0,0);
   if (CurrBar != PrevBar)
   {
      
      //
      //
      //
      //
      //
      
      int Signal = TradeSignal();
      if (ScanTrades() < MaxOrders)
      {
        if (TimeCondition() && Signal > 0 && canOpen(OP_BUY) ) BuyOrdOpen() ;
        if (TimeCondition() && Signal < 0 && canOpen(OP_SELL)) SellOrdOpen();
      }
      
      //
      //
      //
      //
      //
           
      if (ScanTrades() > 0)
      {
         if (BuyMarketCount()  > 0 && TrailingStop > 0) { BuyTrailingStop();  }
         if (SellMarketCount() > 0 && TrailingStop > 0) { SellTrailingStop(); }
	     
	      //
	      //
	      //
	      //
	      //
	     
	      if (ExitMode == 0)
         {
           if (Signal > 0 && StopLoss > 0 && TakeProfit > 0) 
           {
               StopLoss   = StopLoss   * Point * _Point;
               TakeProfit = TakeProfit * Point * _Point;
           }
           
           if (Signal < 0 && StopLoss > 0 && TakeProfit > 0) 
           {
               StopLoss   = StopLoss   * Point * _Point;
               TakeProfit = TakeProfit * Point * _Point;
           }
         }
         
         //
         //
         //
         //
         //    
	        
         if (ExitMode == 1)
         {
           if (TStrend > 0 && pTStrend < 0) CloseOrder(2);
           if (TStrend < 0 && pTStrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 2)
         {
           if (TEtrend > 0 && pTEtrend < 0) CloseOrder(2);
           if (TEtrend < 0 && pTEtrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 3)
         {
           if (VStrend > 0 && pVStrend < 0) CloseOrder(2);
           if (VStrend < 0 && pVStrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 4)
         {
           if (LT_trendNow < 0 && LT_trendNow > LT_trendPre && ST_trendNow > ST_trendPre && LT_trendNow > LT_sigNow && ST_trendNow > ST_sigNow && ST_trendPre > ST_sigPre) CloseOrder(2);
           if (LT_trendNow > 0 && LT_trendNow < LT_trendPre && ST_trendNow < ST_trendPre && LT_trendNow < LT_sigNow && ST_trendNow < ST_sigNow && ST_trendPre < ST_sigPre) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 5)
         {
           if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0) || (TEtrend > 0 && pTEtrend < 0)) CloseOrder(2);
           if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0) || (TEtrend < 0 && pTEtrend > 0)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 6)
         {
           if (Signal > 0) CloseOrder(2);
           if (Signal < 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 7)
         {
           if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0)||(Bulls > sBulls && Bulls > Bears)) CloseOrder(2);
           if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0)||(Bears > sBears && Bulls < Bears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 8)
         {
           if ((Bulls > sBulls)||(Bears < sBears)) CloseOrder(2);
           if ((Bulls < sBulls)||(Bears > sBears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if (ExitMode == 9)
         {
           if ((TStrend > 0 && pTStrend < 0)||(Bulls > sBulls)) CloseOrder(2);
           if ((TStrend < 0 && pTStrend > 0)||(Bears > sBears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         if (CloseTimeMode > 0)
         {
           datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
           
           if(DayOfWeek() == 5) TimeClose  = StrToTime(FriCloseHour+":"+FriCloseMinute);
           if(TimeCurrent() >=  TimeClose && TimeCurrent() < TimeClose + ProcessTime * 60) while(ScanTrades() > 0) CloseOrder(0); 
         }
	       
         //
         //
         //
         //
         //
         
         }
   }      
   PrevBar = CurrBar;
   return(0);
}

//-----------------------------------------------------
// Function Scan Trades
//-----------------------------------------------------
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  
 
//-----------------------------------------------------
// Function TimeCondition
//-----------------------------------------------------
//
//

bool TimeCondition()
{
   bool result = false;
    
      if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
      {
         if(StartHour == 24) StartHour = 0; 
      
         datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
         double   Start        = StartHour + StartMinute/60.0;
         datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
         double   End          = EndHour + EndMinute/60.0; 
         
         //
         //
         //
         //
         //
         
         if(DayOfWeek() != 1 && DayOfWeek() != 5)
         {    
            if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);  
                
            else
            if (Start > End)result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
                                   
         }
         else
         if(DayOfWeek() == 1)
         {    
            if(MonStartHour > 0 || MonStartMinute > 0) 
            {
            datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
            double   MonStart        = MonStartHour + MonStartMinute/60.0;
            }
            else
            {
            MonSessionStart = StrToTime(0+":"+0); 
            MonStart        = 0;
            }
            
            //
            //
            //
            //
            //
                        
            if (Start < End)
            { 
              if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
                            else result = TimeCurrent() >= SessionStart    && TimeCurrent() < SessionEnd;
            }
            else
            if (Start > End)
            {
               result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd)|| (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59)); 
                     
            }
         }
         else
         if(DayOfWeek() == 5)
         {
            if(FriEndHour > 0 || FriEndMinute > 0)
            {
            datetime FriSessionEnd = StrToTime(FriEndHour+":"+FriEndMinute);
            double   FriEnd        = FriEndHour + FriEndMinute/60.0; 
            }
            else
            {
            FriSessionEnd = SessionEnd;
            FriEnd        = End; 
            }
            
            //
            //
            //
            //
            //
            
            if (Start < End)
            {
              if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
                            else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;                 
            }
            
            else
            if (Start > End)
               result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
                           
         }  
      }
   
   return(result);
}   

//-----------------------------------------------------
// Function TS_Trend
//-----------------------------------------------------
//
//

int TS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TStrend  = iCustom(Symbol(),TS_TimeFrame,"TrendStrength on jurik for ea",0,TS_RsxLength,TS_SmoothLength,TS_SmoothPhase,TS_SmoothDouble,TS_Price,TS_Kv,3,TS_CurBar);
   pTStrend = iCustom(Symbol(),TS_TimeFrame,"TrendStrength on jurik for ea",0,TS_RsxLength,TS_SmoothLength,TS_SmoothPhase,TS_SmoothDouble,TS_Price,TS_Kv,3,TS_CurBar);
   
   //
   //
   //
   //
   //
          
   if (mode == 1)
   {
   if (TStrend > 0) result =  mode;
   if (TStrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (TStrend > 0 && pTStrend < 0) result =  mode;  
   if (TStrend < 0 && pTStrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function TE_Trend
//-----------------------------------------------------
//
//

int TE_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TEtrend  = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar);
   pTEtrend = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar+1);
   
   //
   //
   //
   //
   // 
        
   if (mode == 1)
   {
   if (TEtrend > 0) result =  mode;
   if (TEtrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (TEtrend > 0 && pTEtrend < 0) result =  mode;  
   if (TEtrend < 0 && pTEtrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function VS_Trend
//-----------------------------------------------------
//
//

int VS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   VStrend  = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar);
   pVStrend = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar+1);
   
   //
   //
   //
   //
   //
          
   if (mode == 1)
   {
   if (VStrend > 0) result =  mode;
   if (VStrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (VStrend > 0 && pVStrend < 0) result =  mode;  
   if (VStrend < 0 && pVStrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//-----------------------------------------------------
// Function KST_Trend
//-----------------------------------------------------
//
//

int KST_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   LT_trendNow  = iCustom(NULL,LT_KST_TimeFrame,"KST",LT_KSTType,LT_KSTMaType,LT_KSTSignalMaPeriod,0,LT_KST.BarToCheck);
   LT_trendPre  = iCustom(NULL,LT_KST_TimeFrame,"KST",LT_KSTType,LT_KSTMaType,LT_KSTSignalMaPeriod,0,LT_KST.BarToCheck+1);
   LT_sigNow    = iCustom(NULL,LT_KST_TimeFrame,"KST",LT_KSTType,LT_KSTMaType,LT_KSTSignalMaPeriod,1,LT_KST.BarToCheck);
   LT_sigPre    = iCustom(NULL,LT_KST_TimeFrame,"KST",LT_KSTType,LT_KSTMaType,LT_KSTSignalMaPeriod,1,LT_KST.BarToCheck+1);
   
   ST_trendNow  = iCustom(NULL,ST_KST_TimeFrame,"KST",ST_KSTType,ST_KSTMaType,ST_KSTSignalMaPeriod,0,ST_KST.BarToCheck);
   ST_trendPre  = iCustom(NULL,ST_KST_TimeFrame,"KST",ST_KSTType,ST_KSTMaType,ST_KSTSignalMaPeriod,0,ST_KST.BarToCheck+1);
   ST_sigNow    = iCustom(NULL,ST_KST_TimeFrame,"KST",ST_KSTType,ST_KSTMaType,ST_KSTSignalMaPeriod,1,ST_KST.BarToCheck);
   ST_sigPre    = iCustom(NULL,ST_KST_TimeFrame,"KST",ST_KSTType,ST_KSTMaType,ST_KSTSignalMaPeriod,1,ST_KST.BarToCheck+1);
   
   //
   //
   //
   //
   //
   
   if (mode == 1)
   {
   if (LT_trendNow > LT_trendPre && ST_trendNow > ST_trendPre) result =  mode;
   if (LT_trendNow < LT_trendPre && ST_trendNow < ST_trendPre) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (LT_trendNow < 0 && LT_trendNow > LT_trendPre && ST_trendNow > ST_trendPre && LT_trendNow > LT_sigNow && ST_trendNow > ST_sigNow && ST_trendPre <= ST_sigPre) result =  mode;
   if (LT_trendNow > 0 && LT_trendNow < LT_trendPre && ST_trendNow < ST_trendPre && LT_trendNow < LT_sigNow && ST_trendNow < ST_sigNow && ST_trendPre >= ST_sigPre) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function AbStrength
//-----------------------------------------------------
//
//

int AbStrength(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   Bulls  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",0,AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,AS_CurBar);
   sBulls = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",0,AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,2,AS_CurBar);
   
   Bears  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",0,AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,1,AS_CurBar);
   sBears = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",0,AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,3,AS_CurBar);
   
   //
   //
   //
   //
   //
   
   if (mode == 1)
   {
   if (Bulls > sBulls) result =  mode;
   if (Bears > sBears) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//-----------------------------------------------------
// Function TradeSignal
//-----------------------------------------------------
//
//

int TradeSignal()
{   
   int Signal = 0;
   
   //
   //
   //
   //
   //
   
   if (TS_Mode  > 0 || ExitMode == 1 || ExitMode == 5 || ExitMode == 7 || ExitMode == 9) int TS  = TS_Trend(TS_Mode);   else TS  = 0;
   if (TE_Mode  > 0 || ExitMode == 2 || ExitMode == 5)                                   int TE  = TE_Trend(TE_Mode);   else TE  = 0;
   if (VS_Mode  > 0 || ExitMode == 3 || ExitMode == 5 || ExitMode == 7)                  int VS  = VS_Trend(VS_Mode);   else VS  = 0; 
   if (KST_Mode > 0 || ExitMode == 4)                                                    int KST = KST_Trend(KST_Mode); else KST = 0; 
   if (AS_Mode  > 0 || ExitMode  > 6)                                                    int AS  = AbStrength(AS_Mode); else AS  = 0;    
   
   //
   //
   //
   //
   //
   
   if (TimeCondition())
   {
   if (TE ==  TE_Mode && VS ==  VS_Mode && TS ==  TS_Mode && KST ==  KST_Mode && AS ==  AS_Mode) Signal = 1;
   if (TE == -TE_Mode && VS == -VS_Mode && TS == -TS_Mode && KST == -KST_Mode && AS == -AS_Mode) Signal =-1;
   }  
 
   return(Signal);
}

//-----------------------------------------------------
// Function MoneyManagement (Williams)
//-----------------------------------------------------
//
//

double MoneyManagement()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //--- basic formula
   //
   //
   //
   //
   
   if (MM)
   {
      if (MaxLoss > 0) vol = NormalizeDouble(AccountFreeMargin() * MaxRisk / MaxLoss,2);
      else   
      vol=NormalizeDouble(AccountFreeMargin() * MaxRisk * AccountLeverage() / contract,2);
   }
   else
   vol = Lots;
   
   //--- check min, max and step
   //
   //
   //
   //
   
   vol = NormalizeDouble(vol / lot_step,0) * lot_step;
   if(vol < lot_min) vol = lot_min;
   if(vol > lot_max) vol = lot_max;

return(vol);
} 

//
//
//
//
//

int BuyMarketCount()
{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
			OrderSelect(Counter,SELECT_BY_POS);
			if (OrderSymbol()      != Symbol()) continue;
         if (OrderMagicNumber() != Magic)    continue;   
			if (OrderType()        == OP_BUY)   { OrderCount++; }
		}
	return(OrderCount);
}
	
//
//
//
//
//
	
int SellMarketCount()
{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
			OrderSelect(Counter,SELECT_BY_POS);
			if (OrderSymbol()      != Symbol())  continue;
         if (OrderMagicNumber() != Magic)     continue; 
         if (OrderType()        == OP_SELL)   { OrderCount++; }
		}
	return(OrderCount);
}  

//-----------------------------------------------------
// 
//-----------------------------------------------------
//
//

void BuyTrailingStop()
{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
				OrderSelect(Counter,SELECT_BY_POS);

				// 
				//
				//
				//
				//
				
				double MaxStopLoss = MarketInfo(Symbol(),MODE_BID) - (TrailingStop * Point * _Point);
				       MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit  = MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice();
				double MinProfit   = MinProfit * Point* _Point;
            
            //
            //
            //
            //
            //
            
				if (OrderSymbol()      != Symbol()) continue;
            if (OrderMagicNumber() != Magic)    continue; 
				if (OrderType() == OP_BUY)
				if (CurrentStop < MaxStopLoss && PipsProfit >= MinProfit)
				{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						// 
						//
						//
						//
						//
						
						if(Trailed == false)
						{
								int ErrorCode   = GetLastError();
								string ErrDesc  = ErrorDescription(ErrorCode);

								string ErrAlert = StringConcatenate("Buy Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog   = StringConcatenate("Bid: ",MarketInfo(Symbol(),MODE_BID)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
						}
				}			
		}
}
	
//
//
//
//
//	
	
void SellTrailingStop()
{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
				OrderSelect(Counter,SELECT_BY_POS);

				//
				//
				//
				//
				//
				
				double MaxStopLoss = MarketInfo(Symbol(),MODE_ASK) + (TrailingStop * Point * _Point);
				       MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit  = OrderOpenPrice() - MarketInfo(Symbol(),MODE_ASK);
				double MinProfit   = MinProfit * Point * _Point;

				//
				//
				//
				//
				//
				
				if (OrderSymbol()      != Symbol()) continue;
            if (OrderMagicNumber() != Magic)    continue; 
				if (OrderType() == OP_SELL)
				if ((CurrentStop > MaxStopLoss || CurrentStop == 0) && PipsProfit >= MinProfit)
				{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						//
						//
						//
						//
						//
						
						if(Trailed == false)
						{
								int    ErrorCode = GetLastError();
								string ErrDesc   = ErrorDescription(ErrorCode);

								string ErrAlert  = StringConcatenate("Sell Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog    = StringConcatenate("Ask: ",MarketInfo(Symbol(),MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
						}
		   	}	  		
		}
}


//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

int err = 0; 


void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
         int     err = GetLastError(); checkError("stop loss aplied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c=NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
         int     err = GetLastError(); checkError("stop loss aplied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c=NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void BuyOrdOpen()
{ 
   
   double TakeProfit = 0;
   double StopLoss   = 0;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c = 0; c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
      
         if (!EcnBroker)
         {
            if (StopLoss > 0)   sl = Ask - StopLoss;
            if (TakeProfit > 0) tp = Ask + TakeProfit;
         }            
         int ticket = OrderSend(Symbol(),OP_BUY,MoneyManagement(),Ask,Slippage * _Point,sl,tp,"JTS_buy",Magic,0,Blue); 
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("buy order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,  Ask - StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Ask + TakeProfit);
                 
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   } 	    
}

//
//
//
//
//

void SellOrdOpen()
{        
   double TakeProfit = 0;
   double StopLoss   = 0;
      
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c = 0;c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
      
         if (!EcnBroker)
         {
            if (StopLoss   > 0) sl = Bid + StopLoss;
            if (TakeProfit > 0) tp = Bid - TakeProfit;
         }
         int ticket = OrderSend(Symbol(),OP_SELL,MoneyManagement(),Bid,Slippage * _Point,sl,tp,"JTS_Sell",Magic,0,Red);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("sell order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss > 0)   setStopLoss(ticket,  Bid + StopLoss);
                 if (EcnBroker && TakeProfit > 0) setTakeProfit(ticket,Bid - TakeProfit);
                 
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   }
}

   
//
//
//
//
//
//
//-----------------------------------------------------
// Function CloseOrder
//-----------------------------------------------------

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=OrdersTotal(); i>=0; i--)  
   {
   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()      != Symbol()) continue;
         if (OrderMagicNumber() != Magic)    continue;
         {

      if ((mode == 0 || mode == 1) && OrderType() == OP_BUY )  { result = CloseAtMarket(OrderTicket(),OrderLots(),Aqua); break; }
      if ((mode == 0 || mode == 2) && OrderType() == OP_SELL)  { result = CloseAtMarket(OrderTicket(),OrderLots(),Pink); break; }
      }
   }
}

//-----------------------------------------------------
// Function CloseAtMarket
//-----------------------------------------------------
//
//

bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage * Point * _Point,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != Symbol())                       continue;
      if (!StrictNoHedge && OrderMagicNumber() != Magic)   continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL)   return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)    return(false); 
   }      
   return(true);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(8821);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(8822);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(8831);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(8832);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(8841);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(8842);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(8851);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(8861);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(8862);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(8863);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(8864);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(8865);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(8866);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(8867);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(8871);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(8872);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(8873);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(8881);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(8882);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(8883);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(8891);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(8892);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(8893);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(8894);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(8895);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
return(ManualMagic);
}

//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status = false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
return(status);
}

//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>=0; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i <= msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}